Edje Object Animation
Edje » Edje Object

Functions that deal with animations. More...

## Typedefs

typedef enum _Edje_Tween_Mode | Edje_Tween_Mode
| Available tween mode for edje animations.
typedef enum _Edje_Action_Type | Edje_Action_Type
| All actions available in Edje programs.

## Enumerations

enum

_Edje_Tween_Mode {
EDJE_TWEEN_MODE_NONE = 0 ,
EDJE_TWEEN_MODE_LINEAR = 1 ,
EDJE_TWEEN_MODE_SINUSOIDAL = 2 ,
EDJE_TWEEN_MODE_ACCELERATE = 3 ,
EDJE_TWEEN_MODE_DECELERATE = 4 ,
EDJE_TWEEN_MODE_ACCELERATE_FACTOR = 5 ,
EDJE_TWEEN_MODE_DECELERATE_FACTOR = 6 ,
EDJE_TWEEN_MODE_SINUSOIDAL_FACTOR = 7 ,
EDJE_TWEEN_MODE_DIVISOR_INTERP = 8 ,
EDJE_TWEEN_MODE_BOUNCE = 9 ,
EDJE_TWEEN_MODE_SPRING = 10 ,
EDJE_TWEEN_MODE_CUBIC_BEZIER = 11 ,
EDJE_TWEEN_MODE_LAST = 12 ,
EDJE_TWEEN_MODE_MASK = 0xff ,
EDJE_TWEEN_MODE_OPT_FROM_CURRENT = (1 << 31)
}

enum

_Edje_Action_Type {
EDJE_ACTION_TYPE_NONE = 0 ,
EDJE_ACTION_TYPE_STATE_SET = 1 ,
EDJE_ACTION_TYPE_ACTION_STOP = 2 ,
EDJE_ACTION_TYPE_SIGNAL_EMIT = 3 ,
EDJE_ACTION_TYPE_DRAG_VAL_SET = 4 ,
EDJE_ACTION_TYPE_DRAG_VAL_STEP = 5 ,
EDJE_ACTION_TYPE_DRAG_VAL_PAGE = 6 ,
EDJE_ACTION_TYPE_SCRIPT = 7 ,
EDJE_ACTION_TYPE_FOCUS_SET = 8 ,
EDJE_ACTION_TYPE_RESERVED00 = 9 ,
EDJE_ACTION_TYPE_FOCUS_OBJECT = 10 ,
EDJE_ACTION_TYPE_PARAM_COPY = 11 ,
EDJE_ACTION_TYPE_PARAM_SET = 12 ,
EDJE_ACTION_TYPE_SOUND_SAMPLE = 13 ,
EDJE_ACTION_TYPE_SOUND_TONE = 14 ,
EDJE_ACTION_TYPE_PHYSICS_IMPULSE = 15 ,
EDJE_ACTION_TYPE_PHYSICS_TORQUE_IMPULSE = 16 ,
EDJE_ACTION_TYPE_PHYSICS_FORCE = 17 ,
EDJE_ACTION_TYPE_PHYSICS_TORQUE = 18 ,
EDJE_ACTION_TYPE_PHYSICS_FORCES_CLEAR = 19 ,
EDJE_ACTION_TYPE_PHYSICS_VEL_SET = 20 ,
EDJE_ACTION_TYPE_PHYSICS_ANG_VEL_SET = 21 ,
EDJE_ACTION_TYPE_PHYSICS_STOP = 22 ,
EDJE_ACTION_TYPE_PHYSICS_ROT_SET = 23 ,
EDJE_ACTION_TYPE_VIBRATION_SAMPLE = 24 ,
EDJE_ACTION_TYPE_MO = 25 ,
EDJE_ACTION_TYPE_VG_ANIM_STOP = 26 ,
EDJE_ACTION_TYPE_VG_ANIM_PAUSE = 27 ,
EDJE_ACTION_TYPE_VG_ANIM_RESUME = 28 ,
EDJE_ACTION_TYPE_VG_ANIM_PLAY = 29 ,
EDJE_ACTION_TYPE_VG_ANIM_REWIND = 30 ,
EDJE_ACTION_TYPE_VG_ANIM_LOOP = 31 ,
EDJE_ACTION_TYPE_LAST = 32
}

## Functions

void | edje_frametime_set (double t)
| Sets edje transitions' frame time.
double | edje_frametime_get (void)
| Gets edje transitions' frame time.
void | edje_freeze (void)
| Freezes Edje objects.
void | edje_thaw (void)
| Thaws Edje objects.
void | edje_language_set (const char *locale)
| Sets Edje language.
void | edje_transition_duration_factor_set (double scale)
| Sets edje transition duration factor.
double | edje_transition_duration_factor_get (void)
| Retrieves transitions duration factor.

## Detailed Description

Functions that deal with animations.

Edje has the ability to animate objects. One can start, stop, play, pause, freeze, and thaw edje animations using the functions of this section.

## Enumeration Type Documentation

## _Edje_Tween_Mode

enum _Edje_Tween_Mode

Enumerator
EDJE_TWEEN_MODE_NONE | None tween mode value.
EDJE_TWEEN_MODE_LINEAR | Linear tween mode value.
EDJE_TWEEN_MODE_SINUSOIDAL | Sinusoidal tween mode value.
EDJE_TWEEN_MODE_ACCELERATE | Accelerate tween mode value.
EDJE_TWEEN_MODE_DECELERATE | Decelerate tween mode value.
EDJE_TWEEN_MODE_ACCELERATE_FACTOR | Accelerate factor tween mode value.
EDJE_TWEEN_MODE_DECELERATE_FACTOR | Decelerate factor tween mode value.
EDJE_TWEEN_MODE_SINUSOIDAL_FACTOR | Sinusoidal factor tween mode value.
EDJE_TWEEN_MODE_DIVISOR_INTERP | Divisor iterp tween mode value.
EDJE_TWEEN_MODE_BOUNCE | Bounce tween mode value.
EDJE_TWEEN_MODE_SPRING | Spring tween mode value.
EDJE_TWEEN_MODE_CUBIC_BEZIER | Cubic Bezier tween mode value.
EDJE_TWEEN_MODE_LAST | Last tween mode value.
EDJE_TWEEN_MODE_MASK | Mask tween mode value.
EDJE_TWEEN_MODE_OPT_FROM_CURRENT | Options from current tween mode value.

## _Edje_Action_Type

enum _Edje_Action_Type

Enumerator
EDJE_ACTION_TYPE_NONE | None action value.
EDJE_ACTION_TYPE_STATE_SET | State set action value.
EDJE_ACTION_TYPE_ACTION_STOP | Action stop action value.
EDJE_ACTION_TYPE_SIGNAL_EMIT | Signal emit action value.
EDJE_ACTION_TYPE_DRAG_VAL_SET | Drag val set action value.
EDJE_ACTION_TYPE_DRAG_VAL_STEP | Drag val step action value.
EDJE_ACTION_TYPE_DRAG_VAL_PAGE | Drag val page action value.
EDJE_ACTION_TYPE_SCRIPT | Script action value.
EDJE_ACTION_TYPE_FOCUS_SET | Focus set action value.
EDJE_ACTION_TYPE_RESERVED00 | Reversed do action value.
EDJE_ACTION_TYPE_FOCUS_OBJECT | Focus object action value.
EDJE_ACTION_TYPE_PARAM_COPY | Param copy action value.
EDJE_ACTION_TYPE_PARAM_SET | Param set action value.

EDJE_ACTION_TYPE_SOUND_SAMPLE

Sound sample action value.

Since
  1.1

EDJE_ACTION_TYPE_SOUND_TONE

Sound tone action value.

Since
  1.1

EDJE_ACTION_TYPE_PHYSICS_IMPULSE

Physics impulse action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_TORQUE_IMPULSE

Physics torque impulse action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_FORCE

Physics force action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_TORQUE

Physics torque action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_FORCES_CLEAR

Physics forces clear action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_VEL_SET

Physics velocity set action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_ANG_VEL_SET

Physics angle velocity set action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_STOP

Physics stop action value.

Since
  1.8

EDJE_ACTION_TYPE_PHYSICS_ROT_SET

Physics rotation set action value.

Since
  1.8

EDJE_ACTION_TYPE_VIBRATION_SAMPLE

vibration sample action value

Since
  1.10

EDJE_ACTION_TYPE_MO

Mo action value.

Since
  1.15

EDJE_ACTION_TYPE_VG_ANIM_PAUSE

Vector animation stop action value.

Since
  1.24

EDJE_ACTION_TYPE_VG_ANIM_RESUME

Vector animation pause action value.

Since
  1.24

EDJE_ACTION_TYPE_VG_ANIM_PLAY

Vector animation resume action value.

Since
  1.24

EDJE_ACTION_TYPE_VG_ANIM_REWIND

Vector animation play action value.

Since
  1.24

EDJE_ACTION_TYPE_VG_ANIM_LOOP

Vector animation rewind action value.

Since
  1.24

EDJE_ACTION_TYPE_LAST

Vector animation loop value.

Since
  1.24 Last action value

## Function Documentation

## edje_frametime_set()

void edje_frametime_set | ( | double | t | ) |

Sets edje transitions' frame time.

Parameters

  t | The frame time, in seconds. Default value is 1/30.

This function sets the edje built-in animations' frame time (thus, affecting their resolution) by calling ecore_animator_frametime_set(). This frame time can be retrieved with edje_frametime_get().

See also
  edje_frametime_get()

Examples
  edje-perspective.c.

References ecore_animator_frametime_set().

## edje_frametime_get()

double edje_frametime_get | ( | void |  | ) |

Gets edje transitions' frame time.

Returns
  The frame time, in seconds.

This function returns the edje frame time set by edje_frametime_set() or the default value 1/30.

See also
  edje_frametime_set()

References ecore_animator_frametime_get().

## edje_freeze()

void edje_freeze | ( | void |  | ) |

Freezes Edje objects.

This function freezes all Edje animations in the current process.

Note
  : for freeze a specific object

See also
  edje_object_freeze().
  edje_thaw()

References edje_object_freeze(), and EINA_INLIST_FOREACH.

## edje_thaw()

void edje_thaw | ( | void |  | ) |

Thaws Edje objects.

This function thaws all Edje animations in the current process.

Note
  for thaw a specific object

See also
  edje_object_thaw().
  edje_freeze()

References edje_object_thaw(), EINA_FALSE, EINA_INLIST_FOREACH, and EINA_LIST_FREE.

## edje_language_set()

void edje_language_set | ( | const char * | locale | ) |

Sets Edje language.

Parameters

  locale | The locale specifier.

This function sets the given language.

Note
  : emits signal edje,language,"locale".

Since
  1.15

Examples
  edje-text.c.

References alloca(), EINA_INLIST_FOREACH, and eina_stringshare_replace().

Referenced by elm_language_set().

## edje_transition_duration_factor_set()

void edje_transition_duration_factor_set | ( | double | scale | ) |

Sets edje transition duration factor.

Parameters

  scale | The edje transition's duration factor (the default value is `1.0`)

This function sets the edje transition duration factor It will affect the speed of transitions which had the `use_duration_factor` property set to @1. The default value of `use_duration_factor` property is `zero`, but can be changed by `"USE_DURATION_FACTOR 1"` or `"USE_DURATION_FACTOR 0"` as parameter of `"TRANSITION"` property at EDC level. If the parameter is `"USE_DURATION_FACTOR 0"` or not mentioned about `"USE_DURATION_FACTOR"`, the duration of transition keeps original duration

Warning
  The transition's duration factor cannot be set on each translation. If you use this function, it will affect transitions globally

See also
  edje_transition_duration_factor_get()

Since
  1.15

Referenced by elm_config_transition_duration_factor_set().

## edje_transition_duration_factor_get()

double edje_transition_duration_factor_get | ( | void |  | ) |

Retrieves transitions duration factor.

Returns
  The edje transition duration factor

This function returns the edje transition duration factor.

See also
  edje_transition_duration_set() for more details

Since
  1.15